package com.ejie.ab61.model.listados;

import java.sql.Blob;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.ab61.model.parametros.Parametros;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * Listados  
 * 
 *  
 */

public class Listados implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idListado;
	private String nombre;
	private Blob fichero;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private List<Parametros> parametros = new ArrayList<Parametros>();
	private RelLisPro relLisPro;
	private String nombreBusquedas;
	private byte[] ficheroArray;
	private String nombreFichero;
	private String resultado;
	private String rutaPIF;

	/**
	 * Method 'Listados'.
	 */
	public Listados() {
	}

	/**
	 * Method 'Listados'.
	 * 
	 * @param idListado
	 *            Integer
	 */
	public Listados(Integer idListado) {
		this.idListado = idListado;
	}

	/**
	 * Method 'Listados'.
	 * 
	 * @param idListado
	 *            Integer
	 * @param nombre
	 *            String
	 * @param fichero
	 *            Blob
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 */
	public Listados(Integer idListado, String nombre, Blob fichero, Date fechaRegistro, String usuarioRegistro,
			Date fechaUltmodificacion, String usuarioUltmodificacion) {

		this.idListado = idListado;
		this.nombre = nombre;
		this.fichero = fichero;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getIdListado'.
	 *
	 * @return Integer
	 */

	public Integer getIdListado() {
		return this.idListado;
	}

	/**
	 * Method 'setIdListado'.
	 *
	 * @param idListado
	 *            Integer
	 * @return
	 */

	public void setIdListado(Integer idListado) {
		this.idListado = idListado;
	}

	/**
	 * Method 'getNombre'.
	 *
	 * @return String
	 */

	public String getNombre() {
		return this.nombre;
	}

	/**
	 * Method 'setNombre'.
	 *
	 * @param nombre
	 *            String
	 * @return
	 */

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	/**
	 * Method 'getFichero'.
	 *
	 * @return Blob
	 */
	@JsonIgnore

	public Blob getFichero() {
		return this.fichero;
	}

	/**
	 * Method 'setFichero'.
	 *
	 * @param fichero
	 *            Blob
	 * @return
	 */

	public void setFichero(Blob fichero) {
		this.fichero = fichero;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	public List<Parametros> getParametros() {
		return parametros;
	}

	public void setParametros(List<Parametros> parametros) {
		this.parametros = parametros;
	}

	/**
	 * @return the relLisPro
	 */
	public RelLisPro getRelLisPro() {
		return this.relLisPro;
	}

	/**
	 * @param relLisPro
	 *            the relLisPro to set
	 */
	public void setRelLisPro(RelLisPro relLisPro) {
		this.relLisPro = relLisPro;
	}

	/**
	 * @return the nombreBusquedas
	 */
	public String getNombreBusquedas() {
		return nombreBusquedas;
	}

	/**
	 * @param nombreBusquedas
	 *            the nombreBusquedas to set
	 */
	public void setNombreBusquedas(String nombreBusquedas) {
		this.nombreBusquedas = nombreBusquedas;
	}

	/**
	 * @return the ficheroArray
	 */
	public byte[] getFicheroArray() {
		return ficheroArray;
	}

	/**
	 * @param ficheroArray
	 *            the ficheroArray to set
	 */
	public void setFicheroArray(byte[] ficheroArray) {
		this.ficheroArray = ficheroArray;
	}

	/**
	 * @return the nombreFichero
	 */
	public String getNombreFichero() {
		return nombreFichero;
	}

	/**
	 * @param nombreFichero
	 *            the nombreFichero to set
	 */
	public void setNombreFichero(String nombreFichero) {
		this.nombreFichero = nombreFichero;
	}

	/**
	 * @return the resultado
	 */
	public String getResultado() {
		return resultado;
	}

	/**
	 * @param resultado
	 *            the resultado to set
	 */
	public void setResultado(String resultado) {
		this.resultado = resultado;
	}

	/**
	 * @return the rutaPIF
	 */
	public String getRutaPIF() {
		return rutaPIF;
	}

	/**
	 * @param rutaPIF
	 *            the rutaPIF to set
	 */
	public void setRutaPIF(String rutaPIF) {
		this.rutaPIF = rutaPIF;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idListado: ").append(this.idListado).append(" ]");
		result.append(", [ nombre: ").append(this.nombre).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}
}
